pcl::ExtractIndices< PointT > Class Template Reference
Module filters

ExtractIndices extracts a set of indices from a point cloud. More...

`#include <pcl/filters/extract_indices.h>`

Inheritance diagram for pcl::ExtractIndices< PointT >:

## Public Types

typedef boost::shared_ptr< ExtractIndices< PointT > > | Ptr
typedef boost::shared_ptr< const ExtractIndices< PointT > > | ConstPtr
Public Types inherited from pcl::FilterIndices< PointT >
typedef pcl::PointCloud< PointT > | PointCloud
typedef boost::shared_ptr< FilterIndices< PointT > > | Ptr
typedef boost::shared_ptr< const FilterIndices< PointT > > | ConstPtr
Public Types inherited from pcl::Filter< PointT >
typedef boost::shared_ptr< Filter< PointT > > | Ptr
typedef boost::shared_ptr< const Filter< PointT > > | ConstPtr
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
Public Types inherited from pcl::PCLBase< PointT >
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| ExtractIndices (bool extract_removed_indices=false)
| Constructor. More...
void | filterDirectly (PointCloudPtr &cloud)
| Apply the filter and store the results directly in the input cloud. More...
Public Member Functions inherited from pcl::FilterIndices< PointT >
| FilterIndices (bool extract_removed_indices=false)
| Constructor. More...
virtual | ~FilterIndices ()
| Empty virtual destructor. More...
void | filter (PointCloud &output)
void | filter (std::vector< int > &indices)
| Calls the filtering method and returns the filtered point cloud indices. More...
void | setNegative (bool negative)
| Set whether the regular conditions for points filtering should apply, or the inverted conditions. More...
bool | getNegative ()
| Get whether the regular conditions for points filtering should apply, or the inverted conditions. More...
void | setKeepOrganized (bool keep_organized)
| Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
bool | getKeepOrganized ()
| Get whether the filtered points should be kept and set to the value given through setUserFilterValue (default = NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
void | setUserFilterValue (float value)
| Provide a value that the filtered points should be set to instead of removing them. More...
Public Member Functions inherited from pcl::Filter< PointT >
| Filter (bool extract_removed_indices=false)
| Empty constructor. More...
virtual | ~Filter ()
| Empty destructor. More...
IndicesConstPtr const | getRemovedIndices ()
| Get the point indices being removed. More...
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed. More...
void | filter (PointCloud &output)
| Calls the filtering method and returns the filtered dataset in output. More...
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Types

typedef FilterIndices< PointT >::PointCloud | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef pcl::traits::fieldList< PointT >::type | FieldList

## Protected Member Functions

void | applyFilter (PointCloud &output)
| Filtered results are stored in a separate point cloud. More...
void | applyFilter (std::vector< int > &indices)
| Filtered results are indexed by an indices array. More...
void | applyFilterIndices (std::vector< int > &indices)
| Filtered results are indexed by an indices array. More...
Protected Member Functions inherited from pcl::Filter< PointT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Additional Inherited Members

Protected Attributes inherited from pcl::FilterIndices< PointT >
bool | negative_
| False = normal filter behavior (default), true = inverted behavior. More...
bool | keep_organized_
| False = remove points (default), true = redefine points, keep structure. More...
float | user_filter_value_
| The user given value that the filtered point dimensions should be set to (default = NaN). More...
Protected Attributes inherited from pcl::Filter< PointT >
IndicesPtr | removed_indices_
| Indices of the points that are removed. More...
std::string | filter_name_
| The filter name. More...
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points. More...
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointT>
class pcl::ExtractIndices< PointT >

ExtractIndices extracts a set of indices from a point cloud.

Usage example:

pcl::ExtractIndices<PointType> eifilter (true); // Initializing with true will allow us to extract the removed indices
eifilter.setInputCloud (cloud_in);
eifilter.setIndices (indices_in);
eifilter.filter (*cloud_out);
// The resulting cloud_out contains all points of cloud_in that are indexed by indices_in
indices_rem = eifilter.getRemovedIndices ();
// The indices_rem array indexes all points of cloud_in that are not indexed by indices_in
eifilter.setNegative (true);
eifilter.filter (*indices_out);
// Alternatively: the indices_out array is identical to indices_rem
eifilter.setNegative (false);
eifilter.setUserFilterValue (1337.0);
eifilter.filterDirectly (cloud_in);
// This will directly modify cloud_in instead of creating a copy of the cloud
// It will overwrite all fields of the filtered points by the user value: 1337

Author
  Radu Bogdan Rusu

Definition at line 70 of file extract_indices.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointT>

typedef boost::shared_ptr< const ExtractIndices<PointT> > pcl::ExtractIndices< PointT >::ConstPtr

Definition at line 81 of file extract_indices.h.

## FieldList

template<typename PointT>

typedef pcl::traits::fieldList<PointT>::type pcl::ExtractIndices< PointT >::FieldList

protected

Definition at line 76 of file extract_indices.h.

## PointCloud

template<typename PointT>

typedef FilterIndices<PointT>::PointCloud pcl::ExtractIndices< PointT >::PointCloud

protected

Definition at line 73 of file extract_indices.h.

## PointCloudConstPtr

template<typename PointT>

typedef PointCloud::ConstPtr pcl::ExtractIndices< PointT >::PointCloudConstPtr

protected

Definition at line 75 of file extract_indices.h.

## PointCloudPtr

template<typename PointT>

typedef PointCloud::Ptr pcl::ExtractIndices< PointT >::PointCloudPtr

protected

Definition at line 74 of file extract_indices.h.

## Ptr

template<typename PointT>

typedef boost::shared_ptr< ExtractIndices<PointT> > pcl::ExtractIndices< PointT >::Ptr

Definition at line 80 of file extract_indices.h.

## Constructor & Destructor Documentation

## ExtractIndices()

template<typename PointT>

pcl::ExtractIndices< PointT >::ExtractIndices | ( | bool | extract_removed_indices = `false` | ) |

inline

Constructor.

Parameters

  [in] | extract_removed_indices | Set to true if you want to be able to extract the indices of points being removed (default = false).

Definition at line 86 of file extract_indices.h.

References pcl::ExtractIndices< PointT >::applyFilter(), pcl::Filter< PointT >::filter_name_, pcl::ExtractIndices< PointT >::filterDirectly(), and pcl::PCLBase< PointT >::use_indices_.

## Member Function Documentation

## applyFilter() [1/2]

template<typename PointT >

void pcl::ExtractIndices< PointT >::applyFilter | ( | PointCloud & | output | ) |

protected virtual

Filtered results are stored in a separate point cloud.

Parameters

  [out] | output | The resultant point cloud.

Implements pcl::FilterIndices< PointT >.

Definition at line 79 of file extract_indices.hpp.

References pcl::copyPointCloud(), pcl::PointCloud< PointT >::is_dense, and pcl::PointCloud< PointT >::points.

Referenced by pcl::ExtractIndices< PointT >::ExtractIndices(), and pcl::ExtractIndices< pcl::PCLPointCloud2 >::ExtractIndices().

## applyFilter() [2/2]

template<typename PointT>

void pcl::ExtractIndices< PointT >::applyFilter | ( | std::vector< int > & | indices | ) |

inline protected virtual

Filtered results are indexed by an indices array.

Parameters

  [out] | indices | The resultant indices.

Implements pcl::FilterIndices< PointT >.

Definition at line 126 of file extract_indices.h.

References pcl::ExtractIndices< PointT >::applyFilterIndices().

## applyFilterIndices()

template<typename PointT >

void pcl::ExtractIndices< PointT >::applyFilterIndices | ( | std::vector< int > & | indices | ) |

protected

Filtered results are indexed by an indices array.

Parameters

  [out] | indices | The resultant indices.

Definition at line 118 of file extract_indices.hpp.

Referenced by pcl::ExtractIndices< PointT >::applyFilter().

## filterDirectly()

template<typename PointT >

void pcl::ExtractIndices< PointT >::filterDirectly | ( | PointCloudPtr & | cloud | ) |

Apply the filter and store the results directly in the input cloud.

This method will save the time and memory copy of an output cloud but can not alter the original size of the input cloud: It operates as though setKeepOrganized() is true and will overwrite the filtered points instead of remove them. All fields of filtered points are replaced with the value set by setUserFilterValue() (default = NaN). This method also automatically alters the input cloud set via setInputCloud(). It does not alter the value of the internal keep organized boolean as set by setKeepOrganized().

Parameters

  cloud | The point cloud used for input and output.

Definition at line 48 of file extract_indices.hpp.

Referenced by pcl::ExtractIndices< PointT >::ExtractIndices().

The documentation for this class was generated from the following files:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/filters/include/pcl/filters/extract_indices.h
- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/filters/include/pcl/filters/impl/extract_indices.hpp